diff -r -u pgadmin3-before/pgadmin/ctl/calbox.cpp pgadmin3/pgadmin/ctl/calbox.cpp
--- pgadmin3-before/pgadmin/ctl/calbox.cpp	2011-03-08 10:02:03.000000000 +0100
+++ pgadmin3/pgadmin/ctl/calbox.cpp	2011-03-09 09:23:14.000000000 +0100
@@ -274,7 +274,11 @@
 	wxDateTime dt;
 	dt.ParseFormat(wxT("2003-10-13"), wxT("%Y-%m-%d"));
 	wxString str = dt.Format(fmt);
+#if wxCHECK_VERSION(2, 9, 0)
+	const wxChar *p = str.wchar_str();
+#else
 	const wxChar *p = (const wxChar *) str;
+#endif
 
 	m_format = wxEmptyString;
 
@@ -306,7 +310,11 @@
 		wxChar c;
 		for (c = '0'; c <= '9'; c++)
 			valArray.Add(wxString(c, 1));
+#if wxCHECK_VERSION(2, 9, 0)
+		const wxChar *p = m_format.wchar_str();
+#else
 		const wxChar *p = (const wxChar *) m_format;
+#endif
 		while (*p)
 		{
 			if (*p == '%')
diff -r -u pgadmin3-before/pgadmin/ctl/ctlComboBox.cpp pgadmin3/pgadmin/ctl/ctlComboBox.cpp
--- pgadmin3-before/pgadmin/ctl/ctlComboBox.cpp	2011-03-08 10:02:03.000000000 +0100
+++ pgadmin3/pgadmin/ctl/ctlComboBox.cpp	2011-03-09 09:26:24.000000000 +0100
@@ -32,7 +32,11 @@
 
 int ctlComboBoxFix::Append(const wxString &item, const wxString &str)
 {
+#if wxCHECK_VERSION(2, 9, 0)
+	return wxComboBox::Append(item, new StringClientData(str.wchar_str()));
+#else
 	return wxComboBox::Append(item, new StringClientData(str));
+#endif
 }
 
 
diff -r -u pgadmin3-before/pgadmin/frm/frmQuery.cpp pgadmin3/pgadmin/frm/frmQuery.cpp
--- pgadmin3-before/pgadmin/frm/frmQuery.cpp	2011-03-08 10:02:03.000000000 +0100
+++ pgadmin3/pgadmin/frm/frmQuery.cpp	2011-03-09 12:41:11.000000000 +0100
@@ -994,7 +994,11 @@
 			pgConn *newconn = dlg.CreateConn(applicationname, createdNewConn);
 			if (newconn && createdNewConn)
 			{
+#if wxCHECK_VERSION(2, 9, 0)
+				cbConnection->Insert(newconn->GetName(), CreateBitmap(GetServerColour(newconn)), sel, (wxClientData *)newconn);
+#else
 				cbConnection->Insert(newconn->GetName(), CreateBitmap(GetServerColour(newconn)), sel, (void *)newconn);
+#endif
 				cbConnection->SetSelection(sel);
 				OnChangeConnection(ev);
 			}
Only in pgadmin3/pgadmin/include: svnversion.h
diff -r -u pgadmin3-before/pgadmin/pgAdmin3.cpp pgadmin3/pgadmin/pgAdmin3.cpp
--- pgadmin3-before/pgadmin/pgAdmin3.cpp	2011-03-08 10:02:03.000000000 +0100
+++ pgadmin3/pgadmin/pgAdmin3.cpp	2011-03-09 09:19:26.000000000 +0100
@@ -186,7 +186,11 @@
 	{
 		pgDialog *dlg = new pgDialog;
 		dlg->wxWindowBase::SetFont(settings->GetSystemFont());
+#if wxCHECK_VERSION(2, 9, 0)
+		dlg->LoadResource(this, dlgName.wchar_str());
+#else
 		dlg->LoadResource(this, dlgName);
+#endif
 		dlg->SetTitle(dlgName);
 		dlg->Show();
 	}
@@ -266,18 +270,18 @@
 	{
 #if wxCHECK_VERSION(2, 9, 0)
 		// wxCmdLineEntryDesc is one of the few places in 2.9 where wxT()s have any effect...they break the build
-		{wxCMD_LINE_SWITCH, "h", "help", _("show this help message"), wxCMD_LINE_VAL_NONE, wxCMD_LINE_OPTION_HELP },
-		{wxCMD_LINE_OPTION, "s", "server", _("auto-connect to specified server"), wxCMD_LINE_VAL_STRING},
-		{wxCMD_LINE_SWITCH, "S", "serverstatus", _("open server status window"), wxCMD_LINE_VAL_NONE},
-		{wxCMD_LINE_OPTION, "Sc", "serverstatusconnect", _("connect server status window to database"), wxCMD_LINE_VAL_STRING},
-		{wxCMD_LINE_SWITCH, "q", "query", _("open query tool"), wxCMD_LINE_VAL_NONE},
-		{wxCMD_LINE_OPTION, "qc", "queryconnect", _("connect query tool to database"), wxCMD_LINE_VAL_STRING},
-		{wxCMD_LINE_OPTION, "f", "file", _("file to load into the query tool in -q or -qc mode"), wxCMD_LINE_VAL_STRING},
-		{wxCMD_LINE_OPTION, "cm", NULL, _("edit main configuration file"), wxCMD_LINE_VAL_STRING, wxCMD_LINE_PARAM_MULTIPLE},
-		{wxCMD_LINE_OPTION, "ch", NULL, _("edit HBA configuration file"), wxCMD_LINE_VAL_STRING, wxCMD_LINE_PARAM_MULTIPLE},
-		{wxCMD_LINE_OPTION, "cp", NULL, _("edit pgpass configuration file"), wxCMD_LINE_VAL_STRING, wxCMD_LINE_PARAM_MULTIPLE},
-		{wxCMD_LINE_OPTION, "c", NULL, _("edit configuration files in cluster directory"), wxCMD_LINE_VAL_STRING, wxCMD_LINE_PARAM_MULTIPLE},
-		{wxCMD_LINE_SWITCH, "t", NULL, _("dialog translation test mode"), wxCMD_LINE_VAL_NONE},
+		{wxCMD_LINE_SWITCH, "h", "help", _("show this help message").mbc_str(), wxCMD_LINE_VAL_NONE, wxCMD_LINE_OPTION_HELP },
+		{wxCMD_LINE_OPTION, "s", "server", _("auto-connect to specified server").mbc_str(), wxCMD_LINE_VAL_STRING},
+		{wxCMD_LINE_SWITCH, "S", "serverstatus", _("open server status window").mbc_str(), wxCMD_LINE_VAL_NONE},
+		{wxCMD_LINE_OPTION, "Sc", "serverstatusconnect", _("connect server status window to database").mbc_str(), wxCMD_LINE_VAL_STRING},
+		{wxCMD_LINE_SWITCH, "q", "query", _("open query tool").mbc_str(), wxCMD_LINE_VAL_NONE},
+		{wxCMD_LINE_OPTION, "qc", "queryconnect", _("connect query tool to database").mbc_str(), wxCMD_LINE_VAL_STRING},
+		{wxCMD_LINE_OPTION, "f", "file", _("file to load into the query tool in -q or -qc mode").mbc_str(), wxCMD_LINE_VAL_STRING},
+		{wxCMD_LINE_OPTION, "cm", NULL, _("edit main configuration file").mbc_str(), wxCMD_LINE_VAL_STRING, wxCMD_LINE_PARAM_MULTIPLE},
+		{wxCMD_LINE_OPTION, "ch", NULL, _("edit HBA configuration file").mbc_str(), wxCMD_LINE_VAL_STRING, wxCMD_LINE_PARAM_MULTIPLE},
+		{wxCMD_LINE_OPTION, "cp", NULL, _("edit pgpass configuration file").mbc_str(), wxCMD_LINE_VAL_STRING, wxCMD_LINE_PARAM_MULTIPLE},
+		{wxCMD_LINE_OPTION, "c", NULL, _("edit configuration files in cluster directory").mbc_str(), wxCMD_LINE_VAL_STRING, wxCMD_LINE_PARAM_MULTIPLE},
+		{wxCMD_LINE_SWITCH, "t", NULL, _("dialog translation test mode").mbc_str(), wxCMD_LINE_VAL_NONE},
 #else
 		{wxCMD_LINE_SWITCH, wxT("h"), wxT("help"), _("show this help message"), wxCMD_LINE_VAL_NONE, wxCMD_LINE_OPTION_HELP },
 		{wxCMD_LINE_OPTION, wxT("s"), wxT("server"), _("auto-connect to specified server"), wxCMD_LINE_VAL_STRING},