diff --git a/doc/src/sgml/func.sgml b/doc/src/sgml/func.sgml
index 5ccece2..37362cd 100644
--- a/doc/src/sgml/func.sgml
+++ b/doc/src/sgml/func.sgml
@@ -12502,6 +12502,10 @@ postgres=# SELECT * FROM unnest2(ARRAY[[1,2],[3,4]]);
    </indexterm>
 
    <indexterm>
+    <primary>session_user</primary>
+   </indexterm>
+
+   <indexterm>
     <primary>user</primary>
     <secondary>current</secondary>
    </indexterm>
@@ -12760,34 +12764,34 @@ SET search_path TO <replaceable>schema</> <optional>, <replaceable>schema</>, ..
        <entry>does current user have privilege for schema</entry>
       </row>
       <row>
-       <entry><literal><function>has_server_privilege</function>(<parameter>user</parameter>,
-                                  <parameter>server</parameter>,
+       <entry><literal><function>has_sequence_privilege</function>(<parameter>user</parameter>,
+                                  <parameter>sequence</parameter>,
                                   <parameter>privilege</parameter>)</literal>
        </entry>
        <entry><type>boolean</type></entry>
-       <entry>does user have privilege for foreign server</entry>
+       <entry>does user have privilege for sequence</entry>
       </row>
       <row>
-       <entry><literal><function>has_server_privilege</function>(<parameter>server</parameter>,
+       <entry><literal><function>has_sequence_privilege</function>(<parameter>sequence</parameter>,
                                   <parameter>privilege</parameter>)</literal>
        </entry>
        <entry><type>boolean</type></entry>
-       <entry>does current user have privilege for foreign server</entry>
+       <entry>does current user have privilege for sequence</entry>
       </row>
       <row>
-       <entry><literal><function>has_sequence_privilege</function>(<parameter>user</parameter>,
-                                  <parameter>sequence</parameter>,
+       <entry><literal><function>has_server_privilege</function>(<parameter>user</parameter>,
+                                  <parameter>server</parameter>,
                                   <parameter>privilege</parameter>)</literal>
        </entry>
        <entry><type>boolean</type></entry>
-       <entry>does user have privilege for sequence</entry>
+       <entry>does user have privilege for foreign server</entry>
       </row>
       <row>
-       <entry><literal><function>has_sequence_privilege</function>(<parameter>sequence</parameter>,
+       <entry><literal><function>has_server_privilege</function>(<parameter>server</parameter>,
                                   <parameter>privilege</parameter>)</literal>
        </entry>
        <entry><type>boolean</type></entry>
-       <entry>does current user have privilege for sequence</entry>
+       <entry>does current user have privilege for foreign server</entry>
       </row>
       <row>
        <entry><literal><function>has_table_privilege</function>(<parameter>user</parameter>,
@@ -13192,6 +13196,10 @@ SELECT pg_type_is_visible('myschema.widget'::regtype);
    </indexterm>
 
    <indexterm>
+    <primary>pg_describe_object</primary>
+   <indexterm>
+
+   <indexterm>
     <primary>pg_get_constraintdef</primary>
    </indexterm>
 
@@ -13274,6 +13282,11 @@ SELECT pg_type_is_visible('myschema.widget'::regtype);
        <entry>get SQL name of a data type</entry>
       </row>
       <row>
+       <entry><literal><function>pg_describe_object(<parameter>catalog_id</parameter>, <parameter>object_id</parameter>, <parameter>object_sub_id</parameter>)</function></literal></entry>
+       <entry><type>text</type></entry>
+       <entry>get description of a database object</entry>
+      </row>
+      <row>
        <entry><literal><function>pg_get_constraintdef(<parameter>constraint_oid</parameter>)</function></literal></entry>
        <entry><type>text</type></entry>
        <entry>get definition of a constraint</entry>
@@ -13394,11 +13407,6 @@ SELECT pg_type_is_visible('myschema.widget'::regtype);
        <entry>get the set of database OIDs that have objects in the tablespace</entry>
       </row>
       <row>
-       <entry><literal><function>pg_describe_object(<parameter>catalog_id</parameter>, <parameter>object_id</parameter>, <parameter>object_sub_id</parameter>)</function>)</literal></entry>
-       <entry><type>text</type></entry>
-       <entry>get description of a database object</entry>
-      </row>
-      <row>
        <entry><literal><function>pg_typeof(<parameter>any</parameter>)</function></literal></entry>
        <entry><type>regtype</type></entry>
        <entry>get the data type of any value</entry>