Index: opr_sanity.out
===================================================================
RCS file: /home/projects/pgsql/cvsroot/pgsql/src/test/regress/expected/opr_sanity.out,v
retrieving revision 1.20
diff -u -r1.20 opr_sanity.out
--- opr_sanity.out	2000/08/21 04:48:57	1.20
+++ opr_sanity.out	2000/10/22 06:19:58
@@ -482,8 +482,8 @@
           (p2.pronargs = 1 AND p1.aggbasetype = 0)));
   oid  | aggname | oid |   proname   
 -------+---------+-----+-------------
- 16984 | max     | 768 | int4larger
- 16998 | min     | 769 | int4smaller
+ 16996 | max     | 768 | int4larger
+ 17010 | min     | 769 | int4smaller
 (2 rows)
 
 -- Cross-check finalfn (if present) against its entry in pg_proc.
Index: sanity_check.out
===================================================================
RCS file: /home/projects/pgsql/cvsroot/pgsql/src/test/regress/expected/sanity_check.out,v
retrieving revision 1.12
diff -u -r1.12 sanity_check.out
--- sanity_check.out	2000/07/05 23:02:37	1.12
+++ sanity_check.out	2000/10/22 06:19:58
@@ -40,6 +40,7 @@
  pg_index            | t
  pg_inherits         | t
  pg_language         | t
+ pg_largeobject      | t
  pg_listener         | t
  pg_opclass          | t
  pg_operator         | t
@@ -54,5 +55,5 @@
  shighway            | t
  tenk1               | t
  tenk2               | t
-(44 rows)
+(45 rows)
 