Index: doc/src/sgml/backup.sgml
===================================================================
--- doc/src/sgml/backup.sgml	(head)
+++ doc/src/sgml/backup.sgml	(fixed)
@@ -1425,11 +1425,11 @@
 
   <para>
    It is also possible to use replication methods, such as
-   <productname>Slony</>, to create a slave server with the updated version of
-   <productname>PostgreSQL</>.  The slave can be on the same computer or
+   <productname>Slony</>, to create a standby server with the updated version of
+   <productname>PostgreSQL</>.  The standby can be on the same computer or
    a different computer.  Once it has synced up with the master server
    (running the older version of <productname>PostgreSQL</>), you can
-   switch masters and make the slave the master and shut down the older
+   switch masters and make the standby the master and shut down the older
    database instance.  Such a switch-over results in only several seconds
    of downtime for an upgrade.
   </para>
Index: doc/src/sgml/dblink.sgml
===================================================================
--- doc/src/sgml/dblink.sgml	(head)
+++ doc/src/sgml/dblink.sgml	(fixed)
@@ -623,7 +623,7 @@
    <title>Example</title>
 
    <programlisting>
- select dblink_connect('dbname=dblink_test_slave');
+ select dblink_connect('dbname=dblink_test_standby');
   dblink_connect
  ----------------
   OK
Index: doc/src/sgml/external-projects.sgml
===================================================================
--- doc/src/sgml/external-projects.sgml	(head)
+++ doc/src/sgml/external-projects.sgml	(fixed)
@@ -240,7 +240,7 @@
    <productname>PostgreSQL</> replication solutions are developed
    externally. For example, <application> <ulink
    url="http://www.slony.info">Slony-I</ulink></> is a popular
-   master/slave replication solution that is developed independently
+   master/standby replication solution that is developed independently
    from the core project.
   </para>
 
Index: doc/src/sgml/high-availability.sgml
===================================================================
--- doc/src/sgml/high-availability.sgml	(head)
+++ doc/src/sgml/high-availability.sgml	(fixed)
@@ -161,21 +161,21 @@
   </varlistentry>
 
   <varlistentry>
-   <term>Trigger-Based Master-Slave Replication</term>
+   <term>Trigger-Based Master-Standby Replication</term>
    <listitem>
 
     <para>
-     A master-slave replication setup sends all data modification
+     A master-standby replication setup sends all data modification
      queries to the master server.  The master server asynchronously
-     sends data changes to the slave server.  The slave can answer
+     sends data changes to the standby server.  The standby can answer
      read-only queries while the master server is running.  The
-     slave server is ideal for data warehouse queries.
+     standby server is ideal for data warehouse queries.
     </para>
 
     <para>
      <productname>Slony-I</> is an example of this type of replication, with per-table
-     granularity, and support for multiple slaves.  Because it
-     updates the slave server asynchronously (in batches), there is
+     granularity, and support for multiple standby servers.  Because it
+     updates the standby server asynchronously (in batches), there is
      possible data loss during fail over.
     </para>
    </listitem>
@@ -202,9 +202,9 @@
      this is unacceptable, either the middleware or the application
      must query such values from a single server and then use those
      values in write queries.  Another option is to use this replication
-     option with a traditional master-slave setup, i.e. data modification
+     option with a traditional master-standby setup, i.e. data modification
      queries are sent only to the master and are propagated to the
-     slaves via master-slave replication, not by the replication
+     standby servers via master-standby replication, not by the replication
      middleware.  Care must also be taken that all
      transactions either commit or abort on all servers, perhaps
      using two-phase commit (<xref linkend="sql-prepare-transaction">
@@ -247,7 +247,7 @@
      replication is best for mostly read workloads, though its big
      advantage is that any server can accept write requests &mdash;
      there is no need to partition workloads between master and
-     slave servers, and because the data changes are sent from one
+     standby servers, and because the data changes are sent from one
      server to another, there is no problem with non-deterministic
      functions like <function>random()</>.
     </para>
@@ -291,7 +291,7 @@
      <entry>Shared Disk Failover</entry>
      <entry>File System Replication</entry>
      <entry>Hot/Warm Standby Using PITR</entry>
-     <entry>Trigger-Based Master-Slave Replication</entry>
+     <entry>Trigger-Based Master-Standby Replication</entry>
      <entry>Statement-Based Replication Middleware</entry>
      <entry>Asynchronous Multimaster Replication</entry>
      <entry>Synchronous Multimaster Replication</entry>
@@ -378,7 +378,7 @@
     </row>
 
     <row>
-     <entry>Slaves accept read-only queries</entry>
+     <entry>Standby accept read-only queries</entry>
      <entry align="center"></entry>
      <entry align="center"></entry>
      <entry align="center">Hot only</entry>
@@ -430,7 +430,7 @@
      partitioned by offices, e.g., London and Paris, with a server
      in each office.  If queries combining London and Paris data
      are necessary, an application can query both servers, or
-     master/slave replication can be used to keep a read-only copy
+     master/standby replication can be used to keep a read-only copy
      of the other office's data on each server.
     </para>
    </listitem>
Index: doc/src/sgml/protocol.sgml
===================================================================
--- doc/src/sgml/protocol.sgml	(head)
+++ doc/src/sgml/protocol.sgml	(fixed)
@@ -1315,7 +1315,7 @@
       <para>
        The unique system identifier identifying the cluster. This
        can be used to check that the base backup used to initialize the
-       slave came from the same cluster.
+       standby came from the same cluster.
       </para>
       </listitem>
       </varlistentry>
@@ -1326,7 +1326,7 @@
       </term>
       <listitem>
       <para>
-       Current TimelineID. Also useful to check that the slave is
+       Current TimelineID. Also useful to check that the standby is
        consistent with the master.
       </para>
       </listitem>
Index: doc/src/sgml/release-9.0.sgml
===================================================================
--- doc/src/sgml/release-9.0.sgml	(head)
+++ doc/src/sgml/release-9.0.sgml	(fixed)
@@ -398,7 +398,7 @@
       <para>
        Previously <acronym>WAL</> files could be sent to standby systems only
        as 16 megabytes files; this allows master changes to be sent to the
-       slave with very little delay. There are new <filename>postgresql.conf</>
+       standby with very little delay. There are new <filename>postgresql.conf</>
        and <filename>recovery.conf</> settings to enable this
        feature, as well as extensive <link
        linkend="streaming-replication">documentation</link>.
Index: doc/src/sgml/release-alpha.sgml
===================================================================
--- doc/src/sgml/release-alpha.sgml	(head)
+++ doc/src/sgml/release-alpha.sgml	(fixed)
@@ -126,7 +126,7 @@
          <emphasis>This implementation should be significantly more
          efficient than the old one, and is also more compatible with
          Hot Standby usage.  There is not yet any facility for HS
-         slaves to receive notifications generated on the master,
+         standby servers to receive notifications generated on the master,
          although such a thing is possible in future.</emphasis>
         </para>
        </listitem>
@@ -552,7 +552,7 @@
        <listitem>
         <para>
          Allow read-only connections during recovery, also
-         known as Hot Standby.  This provides a built-in master-slave
+         known as Hot Standby.  This provides a built-in master-standby
          replication solution.
         </para>
        </listitem>